﻿
#include <iostream>

using namespace std;

#include "viplexcoreasync.h"
#include <thread>

bool g_bAPIReturn = false;
void callBack(const uint16_t code, const char *data)
{
    cout << "ViplexCore Demo code:" << code << endl;
    cout << "ViplexCore Demo data:" << data << endl;
    g_bAPIReturn = true;
}

void waitAPIReturn() 
{
    while (!g_bAPIReturn)
    {
        this_thread::sleep_for(std::chrono::milliseconds(1000));
    }
    g_bAPIReturn = false;
}



int main()
{

    string createProgram = "{\"name\":\"Demo\",\"width\":500,\"height\":500,\"tplID\":1,\"winInfo\":{\"height\":100,\"width\":100,\"left\":0,\"top\":0,\"zindex\":0,\"index\":0}}";
    string editProgram = "{\"programID\":1,\"pageID\":1,\"pageInfo\":{\"name\":\"jiemu\",\"widgetContainers\":[{\"audioGroup\":\"\",\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"contents\":{\"widgetGroups\":[],\"widgets\":[{\"id\":1,\"enable\":true,\"repeatCount\":1,\"layout\":{\"y\":\"0\",\"height\":\"100%\",\"x\":\"0\",\"width\":\"100%\"},\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"backgroundMusic\":\"\",\"zOrder\":0,\"displayRatio\":\"FULL\",\"outAnimation\":{\"type\":0,\"duration\":0},\"dataSource\":\"62ea7e60c493c1f860ae256eef8ec89c.png\",\"type\":\"PICTURE\",\"constraints\":[{\"cron\":[],\"endTime\":\"4017-12-30T23:59:59Z+8:00\",\"startTime\":\"1970-01-01T00:00:00Z+8:00\"}],\"border\":{\"borderThickness\":\"2px,3px,5%,6\",\"style\":0,\"backgroundColor\":\"#ff000000\",\"name\":\"border\",\"cornerRadius\":\"2%\",\"effects\":{\"headTailSpacing\":\"\",\"isHeadTail\":false,\"speedByPixelEnable\":true,\"speed\":0,\"animation\":\"CLOCK_WISE\"}},\"inAnimation\":{\"type\":0,\"duration\":1000},\"duration\":3605000,\"name\":\"test.png\",\"originalDataSource\":\"./test.png\",\"functionStorage\":\"\",\"isSupportSpecialEffects\":false}]},\"enable\":true,\"id\":1,\"itemsSource\":\"\",\"layout\":{\"height\":\"1.0\",\"width\":\"1.0\",\"x\":\"0.0\",\"y\":\"0.0\"},\"name\":\"widgetContainers1\",\"pickCount\":0,\"pickPolicy\":\"ORDER\",\"zOrder\":0}]}}";
    string genrateProgram = "{\"programID\":1,\"outPutPath\":\"./temp/\",\"mediasPath\":[{\"oldPath\":\"test\",\"newPath\":\"test\"}]}";
    string trasfromProgram = "{\"sn\": \"BZSA79353N1310006847\",\"iconPath\": \"\",\"iconName\": \"\",\"sendProgramFilePaths\": {\"programPath\": \"./temp/program1\",\"mediasPath\": {\"./test.png\": \"test.png\"}},\"programName\": \"program1\",\"deviceIdentifier\": \"Demo\",\"startPlayAfterTransferred\": true,\"insertPlay\": true}";
    

    std::cout << "nvInit(sdk 初始化)" << endl;
    int ret = -1;
    string sdkRootDir = "./";
    string credentials = "{\"company\":\"NovaStar\",\"phone\":\"029-68216000\",\"email\":\"hr@novastar.tech\"}";
    ret = ViplexCoreAsync::nvInit(sdkRootDir.c_str(), credentials.c_str());


    std::cout << "\n ViplexCore Demo nvSearchTerminalAsync(搜索) begin..." << endl;
    ViplexCoreAsync::nvSearchTerminalAsync(callBack);
    this_thread::sleep_for(std::chrono::milliseconds(3000));
    g_bAPIReturn = false;

    std::cout << "\n ViplexCore Demo nvLoginAsync(登录) begin... ";
    ViplexCoreAsync::nvLoginAsync("{\"sn\":\"BZSA79353N1310006847\",\"username\":\"admin\",\"rememberPwd\":1,\"password\":\"1234567890\",\"loginType\":0}", callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvCreateProgramAsync(创建节目) begin... " << endl;
    ViplexCoreAsync::nvCreateProgramAsync(createProgram.c_str(), callBack);
    waitAPIReturn();


    string requestDatapath = "{\"filePath\":\"./test.png\"}";
    std::cout << "\n ViplexCore Demo nvGetFileMD5Async(获取MD5) begin... " << endl;
    ViplexCoreAsync::nvGetFileMD5Async(requestDatapath.c_str(), callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvSetPageParamAsync(编辑节目) begin... " << endl;
    ViplexCoreAsync::nvSetPageProgramAsync(editProgram.c_str(), callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvMakeProgramAsync(生成节目) begin... " << endl;
    ViplexCoreAsync::nvMakeProgramAsync(genrateProgram.c_str(), callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvStartTransferProgramAsync(发送节目) begin... " << endl;
    ViplexCoreAsync::nvStartTransferProgramAsync(trasfromProgram.c_str(), callBack);
    this_thread::sleep_for(std::chrono::milliseconds(10000));
    g_bAPIReturn = false;

    std::cout << "\n ViplexCore Demo nvGetProgramInfoAsync(获取节目信息) begin... " << endl;
    string requestDatasn = "{\"sn\":\"BZSA79353N1310006847\"}";
    ViplexCoreAsync::nvGetProgramInfoAsync(requestDatasn.c_str(), callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvSetVolumeAsync(设置音量) begin... " << endl;
    ViplexCoreAsync::nvSetVolumeAsync("{\"sn\":\"BZSA79353N1310006847\",\"volumeInfo\":{\"ratio\":60.0}}", callBack);
    waitAPIReturn();

    std::cout << "\n ViplexCore Demo nvGetVolumeAsync(获取音量) begin... "<< endl;
    ViplexCoreAsync::nvGetVolumeAsync("{\"sn\":\"BZSA79353N1310006847\"}", callBack);
    waitAPIReturn();

}

